package de.hft.stuttgart.citydoctor2.connect.edge;


import de.hft.stuttgart.citydoctor2.connect.edge.CppReferenceHandlingBase;
import de.hft.stuttgart.citydoctor2.connect.edge.NativePointerCastException;

public class AutoProSettingsAdvancedSweep extends CppReferenceHandlingBase {
	private native long createCppClass(
			
				boolean advancedSweep_General_printInfo,
				boolean advancedSweep_General_printFilterReasonInfo,
				boolean advancedSweep_General_exportIntermediateStages,
				double advancedSweep_General_minEdgeLength,
				double advancedSweep_General_maxEdgeLength,
				double advancedSweep_General_minDistToSweep,

				boolean advancedSweep_Planarity_Use,
				boolean advancedSweep_Planarity_IgnoreMultiplePoints,
				double advancedSweep_Planarity_PlanarityTolerance,
			
				boolean advancedSweep_SweepPlane_Use,
				boolean advancedSweep_SweepPlane_PushOnly,
				boolean advancedSweep_SweepPlane_PullOnly,
				boolean advancedSweep_SweepPlane_ShortestEdgeFirst,
				boolean advancedSweep_SweepPlane_SmallestFaceFirst,
				boolean advancedSweep_SweepPlane_SmallestDistFirst,
			
				boolean advancedSweep_SweepRotate_Use,
				double advancedSweep_SweepRotate_maxAngle,
				boolean advancedSweep_SweepRotate_SmallestDistFirst,
				boolean advancedSweep_SweepRotate_SmallestAngleFirst,
				boolean advancedSweep_SweepRotate_SmallestFaceFirst
				
			)
			throws OutOfMemoryError;

	private native void disposeCppClass(long ptrToCppAutoPro)
			throws NativePointerCastException;

	private boolean advancedSweep_General_printInfo;
	private boolean advancedSweep_General_printFilterReasonInfo;
	private boolean advancedSweep_General_exportIntermediateStages;
	private double advancedSweep_General_minEdgeLength;
	private double advancedSweep_General_maxEdgeLength;
	private double advancedSweep_General_minDistToSweep;

	private boolean advancedSweep_Planarity_Use;
	private boolean advancedSweep_Planarity_IgnoreMultiplePoints;
	private double advancedSweep_Planarity_PlanarityTolerance;

	private boolean advancedSweep_SweepPlane_Use;
	private boolean advancedSweep_SweepPlane_PushOnly;
	private boolean advancedSweep_SweepPlane_PullOnly;
	private boolean advancedSweep_SweepPlane_ShortestEdgeFirst;
	private boolean advancedSweep_SweepPlane_SmallestFaceFirst;
	private boolean advancedSweep_SweepPlane_SmallestDistFirst;

	private boolean advancedSweep_SweepRotate_Use;
	private double advancedSweep_SweepRotate_maxAngle;
	private boolean advancedSweep_SweepRotate_SmallestDistFirst;
	private boolean advancedSweep_SweepRotate_SmallestAngleFirst;
	private boolean advancedSweep_SweepRotate_SmallestFaceFirst;
	
	public AutoProSettingsAdvancedSweep() {

		set_advancedSweep_General_printInfo(false);
		set_advancedSweep_General_printFilterReasonInfo(false);
		set_advancedSweep_General_exportIntermediateStages(false);
		set_advancedSweep_General_minEdgeLength(2.0);
		set_advancedSweep_General_maxEdgeLength(5.0);
		set_advancedSweep_General_minDistToSweep(0);

		set_advancedSweep_Planarity_Use(false);
		set_advancedSweep_Planarity_IgnoreMultiplePoints(false);
		set_advancedSweep_Planarity_PlanarityTolerance(0.001);

		set_advancedSweep_SweepPlane_Use(false);
		set_advancedSweep_SweepPlane_PushOnly(false);
		set_advancedSweep_SweepPlane_PullOnly(false);
		set_advancedSweep_SweepPlane_ShortestEdgeFirst(false);
		set_advancedSweep_SweepPlane_SmallestFaceFirst(false);
		set_advancedSweep_SweepPlane_SmallestDistFirst(false);
		
		set_advancedSweep_SweepRotate_Use(false);
		set_advancedSweep_SweepRotate_maxAngle(10);
		set_advancedSweep_SweepRotate_SmallestDistFirst(false);
		set_advancedSweep_SweepRotate_SmallestAngleFirst(false);
		set_advancedSweep_SweepRotate_SmallestFaceFirst(false);
				
	}

	/**
	 * Creates an C++ feature object
	 * 
	 * @throws IllegalStateException
	 *             Thrown if the encapsulated "long-Pointer" isn't 0
	 * @throws NativeOutOfMemoryException
	 *             If there is no more memory on the native side
	 * 
	 * @see {@link disposeCppObject}
	 * @see de.hft.stuttgart.citydoctor.connect.edGe.CppReferenceHandlingBase#createCppObject()
	 */
	public void createCppObject() throws IllegalStateException,
			OutOfMemoryError {
		if (0L != ptrToCppObject) {
			throw new IllegalStateException(
					"Can't create new C++ object, there is allready one!");
		}
		// Maybe an exception is thrown
		long tmpPointer = createCppClass(
				is_advancedSweep_General_printInfo(),
				is_advancedSweep_General_printFilterReasonInfo(),
				is_advancedSweep_General_exportIntermediateStages(),
				get_advancedSweep_General_minEdgeLength(),
				get_advancedSweep_General_maxEdgeLength(),
				get_advancedSweep_General_minDistToSweep(),
				

				is_advancedSweep_Planarity_Use(),
				is_advancedSweep_Planarity_IgnoreMultiplePoints(),
				get_advancedSweep_Planarity_PlanarityTolerance(),

				is_advancedSweep_SweepPlane_Use(),
				is_advancedSweep_SweepPlane_PushOnly(),
				is_advancedSweep_SweepPlane_PullOnly(),
				is_advancedSweep_SweepPlane_ShortestEdgeFirst(),
				is_advancedSweep_SweepPlane_SmallestFaceFirst(),
				is_advancedSweep_SweepPlane_SmallestDistFirst(),
				
				is_advancedSweep_SweepRotate_Use(),
				get_advancedSweep_SweepRotate_maxAngle(),
				is_advancedSweep_SweepRotate_SmallestDistFirst(),
				is_advancedSweep_SweepRotate_SmallestAngleFirst(),
				is_advancedSweep_SweepRotate_SmallestFaceFirst()
						
						
				);
		ptrToCppObject = tmpPointer;
	}

	@Override
	public void disposeCppObject() throws NativePointerCastException {
		if (0L != ptrToCppObject) {
			disposeCppClass(ptrToCppObject);
			ptrToCppObject = 0L;
		}
	}

	
	
	
	
	
	public void set_advancedSweep_General_printInfo(boolean advancedSweep_General_printInfo)
	{
		this.advancedSweep_General_printInfo = advancedSweep_General_printInfo;
	}
	public void set_advancedSweep_General_printFilterReasonInfo(boolean advancedSweep_General_printFilterReasonInfo)
	{
		this.advancedSweep_General_printFilterReasonInfo = advancedSweep_General_printFilterReasonInfo;
	}
	public void set_advancedSweep_General_exportIntermediateStages(boolean advancedSweep_General_exportIntermediateStages)
	{
		this.advancedSweep_General_exportIntermediateStages = advancedSweep_General_exportIntermediateStages;
	}
	public void set_advancedSweep_General_minEdgeLength(double advancedSweep_General_minEdgeLength)
	{
		this.advancedSweep_General_minEdgeLength = advancedSweep_General_minEdgeLength;
	}
	public void set_advancedSweep_General_maxEdgeLength(double advancedSweep_General_maxEdgeLength)
	{
		this.advancedSweep_General_maxEdgeLength = advancedSweep_General_maxEdgeLength;
	}
	public void set_advancedSweep_General_minDistToSweep(double advancedSweep_General_minDistToSweep)
	{
		this.advancedSweep_General_minDistToSweep = advancedSweep_General_minDistToSweep;
	}	


	public void set_advancedSweep_Planarity_Use(boolean advancedSweep_Planarity_Use)
	{
		this.advancedSweep_Planarity_Use = advancedSweep_Planarity_Use;
	}
	public void set_advancedSweep_Planarity_IgnoreMultiplePoints(boolean advancedSweep_Planarity_IgnoreMultiplePoints)
	{
		this.advancedSweep_Planarity_IgnoreMultiplePoints = advancedSweep_Planarity_IgnoreMultiplePoints;
	}
	public void set_advancedSweep_Planarity_PlanarityTolerance(double advancedSweep_Planarity_PlanarityTolerance)
	{
		this.advancedSweep_Planarity_PlanarityTolerance = advancedSweep_Planarity_PlanarityTolerance;
	}

	public void set_advancedSweep_SweepPlane_Use(boolean advancedSweep_SweepPlane_Use)
	{
		this.advancedSweep_SweepPlane_Use = advancedSweep_SweepPlane_Use;
	}
	public void set_advancedSweep_SweepPlane_PushOnly(boolean advancedSweep_SweepPlane_PushOnly)
	{
		this.advancedSweep_SweepPlane_PushOnly = advancedSweep_SweepPlane_PushOnly;
	}
	public void set_advancedSweep_SweepPlane_PullOnly(boolean advancedSweep_SweepPlane_PullOnly)
	{
		this.advancedSweep_SweepPlane_PullOnly = advancedSweep_SweepPlane_PullOnly;
	}
	public void set_advancedSweep_SweepPlane_ShortestEdgeFirst(boolean advancedSweep_SweepPlane_ShortestEdgeFirst)
	{
		this.advancedSweep_SweepPlane_ShortestEdgeFirst = advancedSweep_SweepPlane_ShortestEdgeFirst;
	}
	public void set_advancedSweep_SweepPlane_SmallestFaceFirst(boolean advancedSweep_SweepPlane_SmallestFaceFirst)
	{
		this.advancedSweep_SweepPlane_SmallestFaceFirst = advancedSweep_SweepPlane_SmallestFaceFirst;
	}
	public void set_advancedSweep_SweepPlane_SmallestDistFirst(boolean advancedSweep_SweepPlane_SmallestDistFirst)
	{
		this.advancedSweep_SweepPlane_SmallestDistFirst = advancedSweep_SweepPlane_SmallestDistFirst;
	}
	
	public void set_advancedSweep_SweepRotate_Use(boolean advancedSweep_SweepRotate_Use)
	{
		this.advancedSweep_SweepRotate_Use = advancedSweep_SweepRotate_Use;
	}
	public void set_advancedSweep_SweepRotate_maxAngle(double advancedSweep_SweepRotate_maxAngle)
	{
		this.advancedSweep_SweepRotate_maxAngle = advancedSweep_SweepRotate_maxAngle;
	}
	public void set_advancedSweep_SweepRotate_SmallestDistFirst(boolean advancedSweep_SweepRotate_SmallestDistFirst)
	{
		this.advancedSweep_SweepRotate_SmallestDistFirst = advancedSweep_SweepRotate_SmallestDistFirst;
	}		
	public void set_advancedSweep_SweepRotate_SmallestAngleFirst(boolean advancedSweep_SweepRotate_SmallestAngleFirst)
	{
		this.advancedSweep_SweepRotate_SmallestAngleFirst = advancedSweep_SweepRotate_SmallestAngleFirst;
	}	
	public void set_advancedSweep_SweepRotate_SmallestFaceFirst(boolean advancedSweep_SweepRotate_SmallestFaceFirst)
	{
		this.advancedSweep_SweepRotate_SmallestFaceFirst = advancedSweep_SweepRotate_SmallestFaceFirst;
	}	
	
	public boolean is_advancedSweep_General_printInfo()
	{
		return this.advancedSweep_General_printInfo;
	}
	public boolean is_advancedSweep_General_printFilterReasonInfo()
	{
		return this.advancedSweep_General_printFilterReasonInfo;
	}
	public boolean is_advancedSweep_General_exportIntermediateStages()
	{
		return this.advancedSweep_General_exportIntermediateStages;
	}
	public double get_advancedSweep_General_minEdgeLength()
	{
		return this.advancedSweep_General_minEdgeLength;
	}
	public double get_advancedSweep_General_maxEdgeLength()
	{
		return this.advancedSweep_General_maxEdgeLength;
	}
	public double get_advancedSweep_General_minDistToSweep()
	{
		return this.advancedSweep_General_minDistToSweep;
	}

	public boolean is_advancedSweep_Planarity_Use()
	{
		return this.advancedSweep_Planarity_Use;
	}
	public boolean is_advancedSweep_Planarity_IgnoreMultiplePoints()
	{
		return this.advancedSweep_Planarity_IgnoreMultiplePoints;
	}
	public double get_advancedSweep_Planarity_PlanarityTolerance()
	{
		return this.advancedSweep_Planarity_PlanarityTolerance;
	}

	public boolean is_advancedSweep_SweepPlane_Use()
	{
		return this.advancedSweep_SweepPlane_Use;
	}
	public boolean is_advancedSweep_SweepPlane_PushOnly()
	{
		return this.advancedSweep_SweepPlane_PushOnly;
	}
	public boolean is_advancedSweep_SweepPlane_PullOnly()
	{
		return this.advancedSweep_SweepPlane_PullOnly;
	}
	public boolean is_advancedSweep_SweepPlane_ShortestEdgeFirst()
	{
		return this.advancedSweep_SweepPlane_ShortestEdgeFirst;
	}
	public boolean is_advancedSweep_SweepPlane_SmallestFaceFirst()
	{
		return this.advancedSweep_SweepPlane_SmallestFaceFirst;
	}
	public boolean is_advancedSweep_SweepPlane_SmallestDistFirst()
	{
		return this.advancedSweep_SweepPlane_SmallestDistFirst;
	}
	
	public boolean is_advancedSweep_SweepRotate_Use()
	{
		return this.advancedSweep_SweepRotate_Use;
	}
	public double get_advancedSweep_SweepRotate_maxAngle()
	{
		return this.advancedSweep_SweepRotate_maxAngle;
	}
	public boolean is_advancedSweep_SweepRotate_SmallestDistFirst()
	{
		return this.advancedSweep_SweepRotate_SmallestDistFirst;
	}	
	public boolean is_advancedSweep_SweepRotate_SmallestAngleFirst()
	{
		return this.advancedSweep_SweepRotate_SmallestAngleFirst;
	}	
	public boolean is_advancedSweep_SweepRotate_SmallestFaceFirst()
	{
		return this.advancedSweep_SweepRotate_SmallestFaceFirst;
	}	
	

}
