package de.hft.stuttgart.citydoctor2.webservice.database;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.TypedQuery;

import de.hft.stuttgart.citydoctor2.webservice.model.entities.User;

public class UserQueries {

	private UserQueries() {
		// only static use
	}

	public static User getUserForUsername(String username, EntityManager manager) {
		manager.getTransaction().begin();
		TypedQuery<User> q = manager.createQuery("FROM User WHERE mail = ?1", User.class);
		q.setParameter(1, username);
		User user = null;
		try {
			user = q.getSingleResult();
		} catch (NoResultException e) {
			// ignore
		} finally {
			manager.getTransaction().commit();
		}
		return user;
	}
	
	public static void createUser(User user, EntityManager manager) {
		manager.getTransaction().begin();
		try {
			manager.persist(user);
		} finally {
			manager.getTransaction().commit();
		}
	}
	
	public static void deleteUser(User user, EntityManager manager) {
		manager.getTransaction().begin();
		try {
			manager.remove(user);
		} finally {
			manager.getTransaction().commit();
		}
	}

}
